import { ILayer, ILayerPlugin, IStyleAttributeService } from '@antv/l7-core';
import 'reflect-metadata';
/**
 * 根据 Source 原始数据为指定字段创建 Scale，保存在 StyleAttribute 上，供下游插件使用
 */
export default class FeatureScalePlugin implements ILayerPlugin {
    private scaleOptions;
    private getSourceData;
    apply(layer: ILayer, { styleAttributeService, }: {
        styleAttributeService: IStyleAttributeService;
    }): void;
    private isNumber;
    private caculateScalesForAttributes;
    /**
     * @example
     * 'w*h' => ['w', 'h']
     * 'w' => ['w']
     */
    private parseFields;
    private createScale;
    private getDefaultType;
    private createScaleConfig;
    private createDefaultScale;
}
