import BaseLayer from '../../../core/BaseLayer';
import { ILineLayerStyleOptions, IPointLayerStyleOptions, IPolygonLayerStyleOptions, IMaskLayerStyleOptions } from '../../../core/interface';
import lineFillModel from '../../../line/models/tile';
import lineSimpleModel from '../../../line/models/simpleTileLine';
import pointTextModel from '../../../point/models/tileText';
import pointFillModel from '../../../point/models/tile';
import polygonFillModel from '../../../polygon/models/tile';
import maskModel from '../../../mask/models/fill';
declare type ILayerStyleOptions = IPolygonLayerStyleOptions & ILineLayerStyleOptions & IPointLayerStyleOptions & IMaskLayerStyleOptions;
export default class VectorLayer extends BaseLayer<Partial<ILayerStyleOptions & {
    needListen: boolean;
}>> {
    needListen: boolean;
    isVector: boolean;
    isTileLayer: boolean;
    type: string;
    private pickedID;
    init(): this;
    renderModels(isPicking?: boolean): this;
    protected sourceEvent: () => void;
    getPickID(): number | null;
    setPickID(): number | null;
    buildModels(): void;
    rebuildModels(): void;
    protected getModelType(): typeof lineFillModel | typeof lineSimpleModel | typeof pointTextModel | typeof pointFillModel | typeof polygonFillModel | typeof maskModel;
    protected getLineModel(): typeof lineFillModel | typeof lineSimpleModel;
    protected getPointModel(): typeof pointTextModel | typeof pointFillModel;
    protected getDefaultConfig(): {};
}
export {};
