import { ILayer, ILayerService } from '@antv/l7-core';
import { Tile } from '@antv/l7-utils';
export declare const tileVectorParser: string[];
/**
 * 判断当前图层是否是瓦片图层
 * @param layer
 * @returns
 */
export declare function isTileGroup(layer: ILayer): boolean;
export declare function isVectorTile(parserType: string): boolean;
export declare function registerLayers(parentLayer: ILayer, layers: ILayer[]): void;
export declare function getLayerShape(layerType: string, layer: ILayer): string | string[];
export declare function getMaskValue(layerType: string, mask: boolean): boolean;
export declare function getContainerSize(container: HTMLCanvasElement | HTMLElement): DOMRect | {
    width: number;
    height: number;
};
export declare function isTileLoaded(tile: Tile): boolean;
export declare function isTileChildLoaded(tile: Tile): boolean;
export declare function isTileParentLoaded(tile: Tile): boolean;
export declare function tileAllLoad(tile: Tile, callback: () => void): void;
export declare function updateTileVisible(tile: Tile, layers: ILayer[], layerService: ILayerService): void;
