"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _BaseModel2 = _interopRequireDefault(require("../../core/BaseModel"));

var _TileLayer = require("../tileLayer/TileLayer");

var _MapTileLayer = require("../tileLayer/MapTileLayer");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var TileModel = /*#__PURE__*/function (_BaseModel) {
  (0, _inherits2.default)(TileModel, _BaseModel);

  var _super = _createSuper(TileModel);

  function TileModel() {
    (0, _classCallCheck2.default)(this, TileModel);
    return _super.apply(this, arguments);
  }

  (0, _createClass2.default)(TileModel, [{
    key: "getUninforms",
    value: function getUninforms() {
      return {};
    }
  }, {
    key: "getTileLayer",
    value: function getTileLayer(usage) {
      switch (usage) {
        case 'basemap':
          return _MapTileLayer.MapTileLayer;

        default:
          return _TileLayer.TileLayer;
      }
    }
  }, {
    key: "initModels",
    value: function initModels() {
      var source = this.layer.getSource();

      var _this$layer$getLayerC = this.layer.getLayerConfig(),
          usage = _this$layer$getLayerC.usage;

      if (source !== null && source !== void 0 && source.data.isTile && !this.layer.tileLayer) {
        var tileLayer = this.getTileLayer(usage);
        this.layer.tileLayer = new tileLayer({
          parent: this.layer,
          rendererService: this.rendererService,
          mapService: this.mapService,
          layerService: this.layerService,
          pickingService: this.pickingService,
          transforms: source.transforms
        });
      }

      return this.buildModels();
    }
  }, {
    key: "clearModels",
    value: function clearModels() {}
  }, {
    key: "buildModels",
    value: function buildModels() {
      return [];
    }
  }, {
    key: "registerBuiltinAttributes",
    value: function registerBuiltinAttributes() {//
    }
  }]);
  return TileModel;
}(_BaseModel2.default);

exports.default = TileModel;