"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _base = _interopRequireDefault(require("./base"));

var _rasterDataLayer = _interopRequireDefault(require("./layers/rasterDataLayer"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var RasterTiffTile = /*#__PURE__*/function (_TileFactory) {
  (0, _inherits2.default)(RasterTiffTile, _TileFactory);

  var _super = _createSuper(RasterTiffTile);

  function RasterTiffTile(option) {
    var _this;

    (0, _classCallCheck2.default)(this, RasterTiffTile);
    _this = _super.call(this, option);
    _this.parentLayer = option.parent;
    return _this;
  }

  (0, _createClass2.default)(RasterTiffTile, [{
    key: "createTile",
    value: function createTile(tile, initOptions) {
      var _this$parentLayer, _this$parentLayer$get, _this$parentLayer$get2;

      var colorTexture = initOptions.colorTexture,
          opacity = initOptions.opacity,
          domain = initOptions.domain,
          clampHigh = initOptions.clampHigh,
          clampLow = initOptions.clampLow,
          mask = initOptions.mask;
      var rasterData = tile.data;

      if (!rasterData.data) {
        console.warn('raster data not exist!');
        return {
          layers: [],
          layerIDList: []
        };
      }

      var dataType = (_this$parentLayer = this.parentLayer) === null || _this$parentLayer === void 0 ? void 0 : (_this$parentLayer$get = _this$parentLayer.getSource()) === null || _this$parentLayer$get === void 0 ? void 0 : (_this$parentLayer$get2 = _this$parentLayer$get.parser) === null || _this$parentLayer$get2 === void 0 ? void 0 : _this$parentLayer$get2.dataType;
      var layer = new _rasterDataLayer.default({
        visible: tile.isVisible,
        mask: mask
      }).source(rasterData.data, {
        parser: {
          // 数据栅格分为单通道栅格和多通道彩色栅格
          type: dataType === 'rgb' ? 'rasterRgb' : 'raster',
          width: rasterData.width,
          height: rasterData.height,
          extent: tile.bboxPolygon.bbox
        }
      }).style({
        colorTexture: colorTexture,
        opacity: opacity,
        // TODO: 目前从 domain 从父瓦片图层的 style 进行配置，后续考虑从每个时机请求的栅格文件中进行配置
        domain: domain,
        clampHigh: clampHigh,
        clampLow: clampLow
      });
      this.emitRasterEvent([layer]);
      return {
        layers: [layer],
        layerIDList: [layer.id]
      };
    }
  }]);
  return RasterTiffTile;
}(_base.default);

exports.default = RasterTiffTile;