"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TileLayer = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _layerManager = require("../manager/layerManager");

var _base = require("./base");

var _utils = require("../interaction/utils");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var TileLayer = /*#__PURE__*/function (_Base) {
  (0, _inherits2.default)(TileLayer, _Base);

  var _super = _createSuper(TileLayer);

  function TileLayer(_ref) {
    var _parentSource$data;

    var _this;

    var parent = _ref.parent,
        rendererService = _ref.rendererService,
        mapService = _ref.mapService,
        layerService = _ref.layerService,
        pickingService = _ref.pickingService,
        transforms = _ref.transforms;
    (0, _classCallCheck2.default)(this, TileLayer);
    _this = _super.call(this);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "pickColors", {
      select: null,
      active: null
    });
    var parentSource = parent.getSource();

    var _ref2 = (parentSource === null || parentSource === void 0 ? void 0 : (_parentSource$data = parentSource.data) === null || _parentSource$data === void 0 ? void 0 : _parentSource$data.tilesetOptions) || {},
        sourceLayer = _ref2.sourceLayer;

    _this.sourceLayer = sourceLayer;
    _this.parent = parent;
    _this.mapService = mapService;
    _this.layerService = layerService;
    _this.tileLayerManager = new _layerManager.TileLayerManager(parent, mapService, rendererService, pickingService, transforms);

    _this.initTileSetManager();

    _this.bindSubLayerEvent();

    _this.bindSubLayerPick();

    _this.scaleField = _this.parent.getScaleOptions();
    return _this;
  }

  (0, _createClass2.default)(TileLayer, [{
    key: "children",
    get: function get() {
      return this.tileLayerManager.children;
    }
  }, {
    key: "clearPick",
    value: function clearPick(type) {
      // Tip: 瓦片只有在 mousemove 的时候需要设置清除
      if (type === 'mousemove') {
        this.tileLayerManager.tilePickService.clearPick();
      }
    }
    /**
     * 清除 select 的选中状态
     */

  }, {
    key: "clearPickState",
    value: function clearPickState() {
      (0, _utils.clearPickState)(this.children);
    }
    /**
     * 瓦片图层独立的拾取逻辑
     * @param target
     * @returns
     */

  }, {
    key: "pickLayers",
    value: function pickLayers(target) {
      return this.tileLayerManager.pickLayers(target);
    }
  }, {
    key: "setPickState",
    value: function setPickState(layers) {
      (0, _utils.setPickState)(layers, this.pickColors);
    }
  }, {
    key: "bindSubLayerPick",
    value: function bindSubLayerPick() {
      var _this2 = this;

      this.tileLayerManager.tilePickService.on('pick', function (e) {
        // @ts-ignore
        var _e$pickedColors = (0, _slicedToArray2.default)(e.pickedColors, 3),
            r = _e$pickedColors[0],
            g = _e$pickedColors[1],
            b = _e$pickedColors[2];

        if (e.type === 'click') {
          var restLayers = _this2.children.filter(function (child) {
            return child.inited && child.isVisible() && child.isVector;
          }).filter(function (child) {
            return child !== e.layer;
          });

          var renderList = _this2.layerService.getRenderList();

          var color = (0, _utils.setSelect)(restLayers, [r, g, b], renderList);
          _this2.pickColors.select = color;
        } else {
          (0, _utils.setHighlight)(_this2.children, [r, g, b]);
          _this2.pickColors.active = [r, g, b];
        }
      });
      this.tileLayerManager.tilePickService.on('unpick', function () {
        _this2.pickColors.active = null;
      });
    }
  }, {
    key: "bindSubLayerEvent",
    value: function bindSubLayerEvent() {
      var _this3 = this;

      /**
       * layer.on('click', (ev) => {}); // 鼠标左键点击图层事件
       * layer.on('mouseenter', (ev) => {}); // 鼠标进入图层要素
       * layer.on('mousemove', (ev) => {}); // 鼠标在图层上移动时触发
       * layer.on('mouseout', (ev) => {}); // 鼠标移出图层要素时触发
       * layer.on('mouseup', (ev) => {}); // 鼠标在图层上单击抬起时触发
       * layer.on('mousedown', (ev) => {}); // 鼠标在图层上单击按下时触发
       * layer.on('contextmenu', (ev) => {}); // 图层要素点击右键菜单
       *
       *  鼠标在图层外的事件
       * layer.on('unclick', (ev) => {}); // 图层外点击
       * layer.on('unmousemove', (ev) => {}); // 图层外移动
       * layer.on('unmouseup', (ev) => {}); // 图层外鼠标抬起
       * layer.on('unmousedown', (ev) => {}); // 图层外单击按下时触发
       * layer.on('uncontextmenu', (ev) => {}); // 图层外点击右键
       * layer.on('unpick', (ev) => {}); // 图层外的操作的所有事件
       */
      this.parent.on('subLayerClick', function (e) {
        _this3.parent.emit('click', (0, _objectSpread2.default)({}, e));
      });
      this.parent.on('subLayerMouseMove', function (e) {
        return _this3.parent.emit('mousemove', (0, _objectSpread2.default)({}, e));
      });
      this.parent.on('subLayerMouseUp', function (e) {
        return _this3.parent.emit('mouseup', (0, _objectSpread2.default)({}, e));
      });
      this.parent.on('subLayerMouseEnter', function (e) {
        return _this3.parent.emit('mouseenter', (0, _objectSpread2.default)({}, e));
      });
      this.parent.on('subLayerMouseOut', function (e) {
        return _this3.parent.emit('mouseout', (0, _objectSpread2.default)({}, e));
      });
      this.parent.on('subLayerMouseDown', function (e) {
        return _this3.parent.emit('mousedown', (0, _objectSpread2.default)({}, e));
      });
      this.parent.on('subLayerContextmenu', function (e) {
        return _this3.parent.emit('contextmenu', (0, _objectSpread2.default)({}, e));
      }); // vector layer 图层外事件

      this.parent.on('subLayerUnClick', function (e) {
        return _this3.parent.emit('unclick', (0, _objectSpread2.default)({}, e));
      });
      this.parent.on('subLayerUnMouseMove', function (e) {
        return _this3.parent.emit('unmousemove', (0, _objectSpread2.default)({}, e));
      });
      this.parent.on('subLayerUnMouseUp', function (e) {
        return _this3.parent.emit('unmouseup', (0, _objectSpread2.default)({}, e));
      });
      this.parent.on('subLayerUnMouseDown', function (e) {
        return _this3.parent.emit('unmousedown', (0, _objectSpread2.default)({}, e));
      });
      this.parent.on('subLayerUnContextmenu', function (e) {
        return _this3.parent.emit('uncontextmenu', (0, _objectSpread2.default)({}, e));
      });
    }
  }]);
  return TileLayer;
}(_base.Base);

exports.TileLayer = TileLayer;